package com.benyun.project.third.TransferDirect.domain;

import java.math.BigDecimal;
import java.util.Date;

import com.benyun.framework.aspectj.lang.annotation.Excel;
import com.benyun.framework.web.domain.BaseEntity;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

/**
 * 金蝶直接调拨单对象 kingdee_transfer_direct
 *
 * @author benyun
 * @date 2024-01-04
 */

@Data
public class KingdeeTransferDirect extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 流水id */
    private Long id;

    /** 日期 */
    @Excel(name = "日期")
    private String FDate;

    /** 调拨单号 */
    @Excel(name = "调拨单号")
    private String FBillNo;

    /** 单据类型 */
    @Excel(name = "单据类型")
    private String FBillTypeID;

    /** 调入货主类型 */
    @Excel(name = "调入货主类型")
    private String FOwnerTypeIdHead;

    /** 调入货主 */
    @Excel(name = "调入货主")
    private String FOwnerIdHead;

    /** 调出货主类型 */
    @Excel(name = "调出货主类型")
    private String FOwnerTypeOutIdHead;

    /** 调出货主 */
    @Excel(name = "调出货主")
    private String FOwnerOutIdHead;

    /** 调拨方向 */
    @Excel(name = "调拨方向")
    private String FTransferDirect;

    /** 物料编码 */
    @Excel(name = "物料编码")
    private String FMaterialId;

    /** 物料名称 */
    @Excel(name = "物料名称")
    private String FMaterialName;

    /** 调出仓库 */
    @Excel(name = "调出仓库")
    private String FSrcStockId;

    /** 调入仓库 */
    @Excel(name = "调入仓库")
    private String FDestStockId;

    /** 单位 */
    @Excel(name = "单位")
    private String FUnitID;

    /** 数量 */
    @Excel(name = "数量")
    private String FQty;

    /** 成本 */
    @Excel(name = "成本")
    private String FPrice;

    /** 同步状态  0成功   -1 失败 */
    @Excel(name = "同步状态  0成功   -1 失败")
    private String sendFlag;

    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

}
