package com.benyun.project.third.TransferDirect.service;

import java.util.List;
import com.benyun.project.third.TransferDirect.domain.KingdeeTransferDirect;

/**
 * 金蝶直接调拨单Service接口
 *
 * @author benyun
 * @date 2024-01-04
 */
public interface IKingdeeTransferDirectService
{
    /**
     * 查询金蝶直接调拨单
     *
     * @param id 金蝶直接调拨单主键
     * @return 金蝶直接调拨单
     */
    public KingdeeTransferDirect selectKingdeeTransferDirectById(Long id);

    /**
     * 查询金蝶直接调拨单列表
     *
     * @param kingdeeTransferDirect 金蝶直接调拨单
     * @return 金蝶直接调拨单集合
     */
    public List<KingdeeTransferDirect> selectKingdeeTransferDirectList(KingdeeTransferDirect kingdeeTransferDirect);

    /**
     * 新增金蝶直接调拨单
     *
     * @param kingdeeTransferDirect 金蝶直接调拨单
     * @return 结果
     */
    public int insertKingdeeTransferDirect(KingdeeTransferDirect kingdeeTransferDirect);

    /**
     * 修改金蝶直接调拨单
     *
     * @param kingdeeTransferDirect 金蝶直接调拨单
     * @return 结果
     */
    public int updateKingdeeTransferDirect(KingdeeTransferDirect kingdeeTransferDirect);

    /**
     * 批量删除金蝶直接调拨单
     *
     * @param ids 需要删除的金蝶直接调拨单主键集合
     * @return 结果
     */
    public int deleteKingdeeTransferDirectByIds(String ids);

    /**
     * 删除金蝶直接调拨单信息
     *
     * @param id 金蝶直接调拨单主键
     * @return 结果
     */
    public int deleteKingdeeTransferDirectById(Long id);
}
