package com.benyun.project.third.area.domain;

import com.benyun.framework.aspectj.lang.annotation.Excel;
import com.benyun.framework.web.domain.BaseEntity;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

/**
 * 行政区划数据对象 oms_area
 *
 * @author benyun
 * @date 2023-12-14
 */

@Data
public class OmsArea
{
    private static final long serialVersionUID = 1L;

    /** 城市编号 */
    private String id;

    /** 上级 ID */
    @Excel(name = "上级 ID")
    private String pid;

    /** 层级深度；0：省，1：市，2：区，3：镇 */
    @Excel(name = "层级深度；0：省，1：市，2：区，3：镇")
    private Long deep;

    /** 短名称 */
    @Excel(name = "短名称")
    private String name;

    /** 拼音前缀 */
    @Excel(name = "拼音前缀")
    private String pinyinPrefix;

    /** 完整拼音 */
    @Excel(name = "完整拼音")
    private String pinyin;

    /** 编号；如果是添加的数据，此编号为 0；此编号并非唯一，不可代替 id 使用，比如填充的数据将会和上级使用相同的编号 */
    @Excel(name = "编号；如果是添加的数据，此编号为 0；此编号并非唯一，不可代替 id 使用，比如填充的数据将会和上级使用相同的编号")
    private String extId;

    /** 完整名称 */
    @Excel(name = "完整名称")
    private String extName;

}
