package com.benyun.project.third.byKingdeeConfig.domain;

import com.benyun.framework.aspectj.lang.annotation.Excel;
import com.benyun.framework.web.domain.BaseEntity;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.io.Serializable;

/**
 * 系统账户配置信息对象 by_kingdee_config
 *
 * @author benyun
 * @date 2024-01-10
 */

@Data
public class ByKingdeeConfig implements Serializable
{
    private static final long serialVersionUID = 1L;

    /** 流水id */
    private Long id;

    /** 账套id */
    @Excel(name = "账套id")
    private String thirdAcctId;

    /** 第三方appid */
    @Excel(name = "第三方appid")
    private String thirdAppId;

    /** 第三方appsec */
    @Excel(name = "第三方appsec")
    private String thirdAppSec;

    /** 服务器指向地址 */
    @Excel(name = "服务器指向地址")
    private String thirdServerUrl;

    /** 用户名 */
    @Excel(name = "用户名")
    private String thirdUserName;

    /** oms系统url */
    @Excel(name = "oms系统url")
    private String omsUrl;

    /** oms的客户端id */
    @Excel(name = "oms的客户端id")
    private String omsClientId;

    /** oms的项目id */
    @Excel(name = "oms的项目id")
    private String omsProjectId;

    /** oms的项目sec */
    @Excel(name = "oms的项目sec")
    private String omsClientSecret;

    /** oms的项目回调地址 */
    @Excel(name = "oms的项目回调地址")
    private String omsRedirectUri;

    /** 销售出库单指定云仓id */
    @Excel(name = "销售出库单指定云仓id")
    private String sellCloudStockId;

    /** 其它出库单指定云仓id */
    @Excel(name = "其它出库单指定云仓id")
    private String otherCloudStockId;

    /** 其他出库单指定订单类型 */
    @Excel(name = "其他出库单指定订单类型")
    private String otherCloudOrderType;

    /** 直接调拨单指定云仓id */
    @Excel(name = "直接调拨单指定云仓id")
    private String transferCloudStockId;

    /** 扫描的订单时间间隔  默认0分钟 */
    @Excel(name = "扫描的订单时间间隔  默认0分钟")
    private Long orderSpaceTime;

    /** 业务渠道名称 */
    @Excel(name = "业务渠道名称")
    private String channelCode;

    /** 租户id */
    @Excel(name = "租户id")
    private String tenantId;

    /** 失效标识 */
    @Excel(name = "失效标识")
    private String statusFlag;
}
