package com.benyun.project.third.kingdeeDict.domain;

import com.benyun.framework.aspectj.lang.annotation.Excel;
import com.benyun.framework.web.domain.BaseEntity;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.util.Date;

/**
 * 金蝶单据类型字典对象 kingdee_dict
 *
 * @author 冯旺
 * @date 2024-01-04
 */

@Data
public class KingdeeDict
{
    private static final long serialVersionUID = 1L;

    /** 流水ID */
    private Long id;

    /** 单据名称 */
    @Excel(name = "单据名称")
    private String name;

    /** 单据编码 */
    @Excel(name = "单据编码")
    private String number;

    /** 单据类型ID */
    @Excel(name = "单据类型ID")
    private String billTypeId;

    /** 单据所属表单ID */
    @Excel(name = "单据所属表单ID")
    private String billFormId;


    /** 创建时间 */
    @Excel(name = "创建时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;
}
