package com.benyun.project.third.kingdeeStockconfig.service;

import java.util.List;
import com.benyun.project.third.kingdeeStockconfig.domain.KingdeeStockConfig;

/**
 * 金蝶仓库配置信息Service接口
 *
 * @author benyun
 * @date 2024-01-04
 */
public interface IKingdeeStockConfigService
{
    /**
     * 查询金蝶仓库配置信息
     *
     * @param id 金蝶仓库配置信息主键
     * @return 金蝶仓库配置信息
     */
    public KingdeeStockConfig selectKingdeeStockConfigById(Long id);

    /**
     * 查询金蝶仓库配置信息列表
     *
     * @param kingdeeStockConfig 金蝶仓库配置信息
     * @return 金蝶仓库配置信息集合
     */
    public List<KingdeeStockConfig> selectKingdeeStockConfigList(KingdeeStockConfig kingdeeStockConfig);

    /**
     * 新增金蝶仓库配置信息
     *
     * @param kingdeeStockConfig 金蝶仓库配置信息
     * @return 结果
     */
    public int insertKingdeeStockConfig(KingdeeStockConfig kingdeeStockConfig);

    /**
     * 修改金蝶仓库配置信息
     *
     * @param kingdeeStockConfig 金蝶仓库配置信息
     * @return 结果
     */
    public int updateKingdeeStockConfig(KingdeeStockConfig kingdeeStockConfig);

    /**
     * 批量删除金蝶仓库配置信息
     *
     * @param ids 需要删除的金蝶仓库配置信息主键集合
     * @return 结果
     */
    public int deleteKingdeeStockConfigByIds(String ids);

    /**
     * 删除金蝶仓库配置信息信息
     *
     * @param id 金蝶仓库配置信息主键
     * @return 结果
     */
    public int deleteKingdeeStockConfigById(Long id);

    int syncKingdeeStockConfig();

}
