package com.benyun.project.third.longxiang.domain;

import com.benyun.framework.aspectj.lang.annotation.Excel;
import com.benyun.framework.web.domain.BaseEntity;
import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;

import java.util.Date;

/**
 * 同步物料回执信息对象 by_syn_material_msg
 *
 * @author benyun
 * @date 2023-12-08
 */

@Data
public class BySynMaterialMsg
{
    private static final long serialVersionUID = 1L;

    /** 流水id */
    private Long id;

    /** 信息编码 */
    @Excel(name = "信息编码")
    private String msgCode;

    /** 信息文本 */
    @Excel(name = "信息文本")
    private String msgContext;

    /** 回执信息状态码 */
    @Excel(name = "回执信息状态码")
    private String responseCode;

    /** 回执信息文本 */
    @Excel(name = "回执信息文本")
    private String responseMsg;

    /** 操作动作编码 */
    @Excel(name = "操作动作编码")
    private String operateCode;

    /** 同步的物料编码 */
    @Excel(name = "同步的物料编码")
    private String syncMaterialCode;

    /** 同步的渠道编码 */
    @Excel(name = "同步的渠道编码")
    private String syncChannelCode;


    /** 创建时间 */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private Date createTime;

    /** 租户ID */
    @Excel(name = "租户ID")
    private String tenantId;
}
