package com.benyun.project.third.longxiang.domain;

import lombok.Data;

import java.util.List;

@Data
public class OrderQueryParams {

    /**
     * 开始时间
     */
    private String dateBegin;
    /**
     * 结束时间
     */
    private String dateEnd;
    /**
     * 订单时间
     * 1：订单时间；2：发货时间；3：付款时间；4：确认收货时间；5：计划发货时间
     */
    private Long dateType;
    /**
     * 订单ID
     */
    private List<Long> orderIds;
    /**
     * 页码，默认第一页
     */
    private Long pageNum;
    /**
     * 分页大小，最大100，默认20
     */
    private Long pageSize;
    /**
     * 订单编号
     */
    private List<String> rawSourceIds;
    /**
     * 上游平台店铺编号
     */
    private List<String> shopIdList;
    /**
     * 平台订单状态（可多选）
     * 等待买家付款=WAIT_BUYER_PAY，等待卖家发货=WAIT_SELLER_SEND_GOODS（传此状态时实际支付金额即pay节点支付金额=应付金额
     * 才会显示已付款待审核）,等待买家确认收货=WAIT_BUYER_CONFIRM_GOODS,交易成功=TRADE_FINISHED,付款后交易关闭=TRADE_CLOSED,付款前交易关闭=TRADE_CLOSED_BY_TAOBAO；
     */
    private List<String> shopStatusList;
    /**
     * 订单状态（可多选）
     *
     * 待付款：WaitPay；发货中：Delivering；被合并：Merged；异常：Question；被拆分：Split；等供销商|外仓发货：WaitOuterSent；已付款待审核：WaitConfirm；已客审待财审：WaitFConfirm；已发货：Sent；取消：Cancelled
     */
    private List<String> statusList;
    /**
     * 租户ID
     */
    private String tenantId;
    /**
     *
     * 订单上游平台类型，OMS：手工下单；IMPORT:导入；JUSHUITAN：聚水潭；OPENB2B_KINGDEE：金蝶（开放平台B2B渠道）；OPENB2B_U8：用友U8（开放平台B2B渠道）
     */
    private List<String> upSourceChannelList;
}
