package com.benyun.project.third.longxiang.service;

import com.benyun.project.third.longxiang.domain.BySynMaterialMsg;

import java.util.List;

/**
 * 同步物料回执信息Service接口
 *
 * @author benyun
 * @date 2023-12-08
 */
public interface IBySynMaterialMsgService
{
    /**
     * 查询同步物料回执信息
     *
     * @param id 同步物料回执信息主键
     * @return 同步物料回执信息
     */
    public BySynMaterialMsg selectBySynMaterialMsgById(Long id);

    /**
     * 查询同步物料回执信息列表
     *
     * @param bySynMaterialMsg 同步物料回执信息
     * @return 同步物料回执信息集合
     */
    public List<BySynMaterialMsg> selectBySynMaterialMsgList(BySynMaterialMsg bySynMaterialMsg);

    /**
     * 新增同步物料回执信息
     *
     * @param bySynMaterialMsg 同步物料回执信息
     * @return 结果
     */
    public int insertBySynMaterialMsg(BySynMaterialMsg bySynMaterialMsg);

    /**
     * 修改同步物料回执信息
     *
     * @param bySynMaterialMsg 同步物料回执信息
     * @return 结果
     */
    public int updateBySynMaterialMsg(BySynMaterialMsg bySynMaterialMsg);

    /**
     * 批量删除同步物料回执信息
     *
     * @param ids 需要删除的同步物料回执信息主键集合
     * @return 结果
     */
    public int deleteBySynMaterialMsgByIds(String ids);

    /**
     * 删除同步物料回执信息信息
     *
     * @param id 同步物料回执信息主键
     * @return 结果
     */
    public int deleteBySynMaterialMsgById(Long id);
}
