package com.benyun.project.third.material.domain;

import com.benyun.framework.aspectj.lang.annotation.Excel;
import com.benyun.framework.web.domain.BaseEntity;
import lombok.Data;

/**
 * 犇云物料内外对应对象 by_material_out
 *
 * @author benyun
 * @date 2023-12-04
 */

@Data
public class ByMaterialOut extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 流水ID */
    private Long id;

    /**
     * 物料名称
     */
    @Excel(name = "物料名称")
    private String materialName;

    /** 外部渠道code */
    @Excel(name = "外部渠道code")
    private String outChannelCode;

    /** 内部渠道code */
    @Excel(name = "内部渠道code")
    private String inChannelCode;

    /** 外部物料code */
    @Excel(name = "外部物料code")
    private String outMaterialCode;

    /** 内部物料code */
    @Excel(name = "内部物料code")
    private Integer inMaterialCode;

    /** 失效标识 -1失效  0正常 */
    @Excel(name = "失效标识 -1失效  0正常")
    private String flagCode;


    /** 外部物料ID */
    @Excel(name = "外部物料ID")
    private String outMaterialId;
}
